*----------------------------------------------------------*
* BOO_ASM - copyright Norman Dunbar 1993                   *
*----------------------------------------------------------*
* Another POINTER PRANK program, This on simply pops up at *
* after the CONFIG'd time delay and takes over the pointer *
* To quit from this one, HOLD down the ESC key and click   *
* both buttons together to simulate a HOT_DO '.' as for    *
* QPAC2 default boot program.                              *
*----------------------------------------------------------*

           section code

           data    2048

conchan    equ     0               Offset in data area for con channel id


pick3      bra.s   start           Standard skippy bit
           dc.l    0               Align on byte 6
           dc.w    $4afb           Standard job flag
           dc.w    5               Name size
           dc.b    'BOO !'         Name of this job

*--------------------------------------*
* First suspend this job for the delay *
*--------------------------------------*
start      lea.l   delay,a0        Timeout address
           move.w  (a0),d3         Get the timeout (seconds)

*--------------------------------------------------------------*
* Suspend the job for D3.W seconds, contrary to QDOS COMPANION *
* A1 is NOT preserved, I found out the hard way !              *
*--------------------------------------------------------------*
suspend    moveq   #8,d0           MT_SUSJB
           moveq   #-1,d1          Me
           mulu    #50,d3          Make into frames
           bclr    #7,d3           Avoid negative timeouts
           sub.l   a1,a1           Required by trap
           trap    #1              Sleepy bye byes
           move.l  d1,d7           Save the job id for later

*----------------------------------------*
* Job is now awake, lets do the business *
*----------------------------------------*
awake      moveq   #1,d0           IO_OPEN
           moveq   #-1,d1          For me
           moveq   #2,d3           New exclusive channel
           lea.l   condef,a0       Channel name
           trap    #2              Open it
           tst.l   d0              Did it work ?
           bne     killjob         No

flim       moveq   #$6c,d0         IOP_FLIM
           moveq   #0,d2           ?
           moveq   #-1,d3          Timeout
           lea.l   result,a1       Result block
           trap    #3
           tst.l   d0              Ok ?
           bne     killjob         No

outln      moveq   #$7a,d0         IOP_OUTL
           moveq   #0,d1           No shadows
           moveq   #0,d2           No keep
           trap    #3
           tst.l   d0              Ok ?
           bne     killjob         No

swdf       lea.l   main_pntr,a1    Pointer to my main pointer
           lea.l   spr_boo,a5      My main pointer
           move.l  a5,(a1)         Store it
           lea.l   subw_pntr,a1    Pointer to a pointer (help !)
           moveq   #$7d,d0         IOP_SWDF
           trap    #3              Set up my sub windows & pointers etc
           tst.l   d0              OK ?
           bne     killjob         No

           move.l  a0,a2           Save channel id
           moveq   #0,d0           MT_INF
           trap    #1              Get QDOS info
           exg     a0,a2           A2 = SYSTEM_VARIABLES, A0 = channel id
           move.l  #$01000080,d1   Coordinates for initial pointer

*---------------*
* The main loop *
*---------------*
loop       bsr     keyrow          Check for ESC

           move.l  d1,-(a7)        Save coordinates
           moveq   #$7c,d0         IOP_PICK
           move.l  d7,d1           Get my actual job id
           moveq   #8,d2           Make sure I am awake
           moveq   #-1,d3          Timeout
           trap    #3              Pick me to the top, I am in control !
           move.l  (a7)+,d1        Restore coordinates

           moveq   #$71,d0         IOP_RPTR
           moveq   #%00010000,d2   Return if pointer out of window (it can't !)
           lea.l   pointer,a1      Pointer to pointer record
           trap    #3

           bra.s   loop            Let's go round again


keyrow     movem.l d1/d4-d5/d7/a0-a3,-(a7)  Stack em
           moveq   #$11,d0         MT_IPCOM
           lea.l   ipcom,a3        Command string
           trap    #1              Call keyrow(1)
           btst    #3,d1           ESC pressed ?
           movem.l (a7)+,d1/d4-d5/d7/a0-a3  Unstack em
           bne.s   killjob         Yes, quit
           rts                     No, continue

ipcom      dc.b    9,1,0,0         ipcom command to read keyrow 1
           dc.b    0,0,1,2

condef     dc.w    15              Channel for SPTR
           dc.b    'con_512x256a0x0'

subw_pntr  dc.l    0               Pointer to sub windows pointer table
result     ds.w    4               4 words for IOP_FLIM/IOP_OUTL
           dc.w    0               Spare
           dc.w    0               Border colour
           dc.w    0               Border width
           dc.w    0               Paper colour
main_pntr  dc.l    0               Pointer to main window's pointer !?

pointer    ds.w    12              Pointer record for IOP_RPTR


killjob    move.l  d0,d3           Error code
           moveq   #5,d0           MT_FRJOB
           moveq   #-1,d1          Me
           trap    #1              Bye bye
           bra.s   killjob         Just in case !


*--------------*
* CONFIG block *
*--------------*

align      ds.w    0               Align on an even address

config     dc.b    '<<QCFX>>'      Config header
           dc.b    '01'            Config level
           dc.w    5
           dc.b    'Boo !'       Software name
           dc.w    4
           dc.b    '1.00'          Software version

           dc.b    10              Item is an integer
           dc.b    0               No selection key
           dc.w    delay-*         Pointer to delay word
           dc.w    0               No pre-processing
           dc.w    0               No post-processing
           dc.w    desc-*          Pointer to description
           dc.w    attrib-*        Pointer to attributes

           dc.w    -1              End of list

*--------------------------------------------*
* Config data for item 1 - the initial delay *
*--------------------------------------------*
delay      dc.w    60*5            5 minutes delay

desc       dc.w    53
           dc.b    'How long should the job initially delay in seconds ? '

attrib     dc.w    10              10 seconds
           dc.w    655             10 minutes almost


*-------------------------------------------------------*
* Sprite code, generated from Easysprite via Easysource *
*-------------------------------------------------------*
spr_boo    dc.w  $0100,$0000       Form = mode 4, time = static,adaption = pixel
           dc.w  $0021,$002C       X size = 33, y size = 44 pixels
           dc.w  $0000,$0000       new origin for hot spot
           dc.l  cp1_boo-*         Pointer to colour pattern
           dc.l  pm1_boo-*         Pointer to pattern mask
           dc.l  0                 Pointer to next definition

cp1_boo    dc.w  $0707,$FFFF,$FFFF,$F0F0,$0000,$0000
           dc.w  $0C0C,$0000,$0000,$1818,$0000,$0000
           dc.w  $0808,$0000,$0000,$0808,$0000,$0000
           dc.w  $0808,$0000,$0000,$0808,$0000,$0000
           dc.w  $0808,$0000,$0000,$0808,$0000,$0000
           dc.w  $0808,$0000,$0000,$0808,$0000,$0000
           dc.w  $0B08,$C700,$1C00,$C808,$0000,$0000
           dc.w  $0B08,$6D00,$B600,$C808,$0000,$0000
           dc.w  $0B08,$6D00,$B600,$C808,$0000,$0000
           dc.w  $0B08,$6D00,$B600,$C808,$0000,$0000
           dc.w  $0B08,$CD00,$B600,$C808,$0000,$0000
           dc.w  $0B08,$6D00,$B600,$C808,$0000,$0000
           dc.w  $0B08,$6D00,$B600,$0808,$0000,$0000
           dc.w  $0B08,$6D00,$B600,$C808,$0000,$0000
           dc.w  $0B08,$C700,$1C00,$C808,$0000,$0000
           dc.w  $0808,$0000,$0000,$0808,$0000,$0000
           dc.w  $0808,$0000,$0000,$0808,$0000,$0000
           dc.w  $0808,$0000,$0000,$0808,$0000,$0000
           dc.w  $080F,$00FF,$00FF,$08F8,$0000,$0000
           dc.w  $0A0F,$AAFF,$AAFF,$A8F8,$0000,$0000
           dc.w  $383F,$00FF,$00FF,$0EFE,$0000,$0000
           dc.w  $6060,$0000,$0000,$0303,$0000,$0000
           dc.w  $8080,$0000,$0000,$0000,$8080,$0000
           dc.w  $6060,$0000,$0000,$0303,$0000,$0000
           dc.w  $1717,$FFFF,$FFFF,$F4F4,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$1F1F,$FCFC,$7878,$0000,$0000
           dc.w  $0E0E,$0F0F,$F8F8,$3838,$0000,$0000
           dc.w  $0E0E,$0F4F,$F8F9,$3838,$0000,$0000
           dc.w  $0E0E,$0DAD,$D8DA,$38B8,$0000,$0000
           dc.w  $0E0E,$0C4C,$9899,$3838,$0000,$0000
           dc.w  $0E0E,$0C0C,$9898,$3838,$0000,$0000
           dc.w  $0F0F,$1C1C,$9C9C,$7878,$0000,$0000
           dc.w  $0707,$F9F9,$CFCF,$F0F0,$0000,$0000
           dc.w  $0303,$F3F3,$6767,$E0E0,$0000,$0000
           dc.w  $0101,$FEFE,$3F3F,$C0C0,$0000,$0000
           dc.w  $0000,$FFFF,$FFFF,$8080,$0000,$0000
           dc.w  $0000,$6A6A,$ABAB,$0000,$0000,$0000
           dc.w  $0000,$6A6A,$ABAB,$0000,$0000,$0000
           dc.w  $0000,$6060,$0303,$0000,$0000,$0000
           dc.w  $0000,$6A6A,$ABAB,$0000,$0000,$0000
           dc.w  $0000,$2A2A,$AAAA,$0000,$0000,$0000
           dc.w  $0000,$1F1F,$FCFC,$0000,$0000,$0000
           dc.w  $0000,$0000,$0000,$0000,$0000,$0000

pm1_boo    dc.w  $0707,$FFFF,$FFFF,$F0F0,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $3F3F,$FFFF,$FFFF,$FEFE,$0000,$0000
           dc.w  $7F7F,$FFFF,$FFFF,$FFFF,$0000,$0000
           dc.w  $FFFF,$FFFF,$FFFF,$FFFF,$8080,$0000
           dc.w  $7F7F,$FFFF,$FFFF,$FFFF,$0000,$0000
           dc.w  $1F1F,$FFFF,$FFFF,$FCFC,$0000,$0000
           dc.w  $1F1F,$FFFF,$FFFF,$FCFC,$0000,$0000
           dc.w  $1F1F,$FFFF,$FFFF,$FCFC,$0000,$0000
           dc.w  $1F1F,$FFFF,$FFFF,$FCFC,$0000,$0000
           dc.w  $1F1F,$FFFF,$FFFF,$FCFC,$0000,$0000
           dc.w  $1F1F,$FFFF,$FFFF,$FCFC,$0000,$0000
           dc.w  $1F1F,$FFFF,$FFFF,$FCFC,$0000,$0000
           dc.w  $1F1F,$FFFF,$FFFF,$FCFC,$0000,$0000
           dc.w  $1F1F,$FFFF,$FFFF,$FCFC,$0000,$0000
           dc.w  $0F0F,$FFFF,$FFFF,$F8F8,$0000,$0000
           dc.w  $0707,$FFFF,$FFFF,$F0F0,$0000,$0000
           dc.w  $0303,$FFFF,$FFFF,$E0E0,$0000,$0000
           dc.w  $0101,$FFFF,$FFFF,$C0C0,$0000,$0000
           dc.w  $0000,$FFFF,$FFFF,$8080,$0000,$0000
           dc.w  $0000,$FFFF,$FFFF,$8080,$0000,$0000
           dc.w  $0000,$FFFF,$FFFF,$8080,$0000,$0000
           dc.w  $0000,$FFFF,$FFFF,$8080,$0000,$0000
           dc.w  $0000,$7F7F,$FFFF,$0000,$0000,$0000
           dc.w  $0000,$3F3F,$FEFE,$0000,$0000,$0000
           dc.w  $0000,$1F1F,$FCFC,$0000,$0000,$0000

           END
